' SlotCalc
'
' Licensed under GPL V3
'
' Compiled with FreeBasic Windows 0.20 (0.18 or higher required)
' See http://www.freebasic.net

#lang "qb"

DIM slot$(200), r1$(20), r2$(20), slot2(2,200)
nslot = 0
nsize = 500
lyear = val(right$(date$,4))+1

FOR i = 2000 TO lyear
    dx1$ = LTRIM$(RTRIM$(STR$(i)))
    FOR j = 101 TO 112
        dx2$ = RIGHT$(RTRIM$(STR$(j)), 2)
        nslot = nslot + 1
        slot$(nslot) = dx1$ + dx2$
        slot2(1,nslot) = 0
        slot2(2,nslot) = 0
        NEXT j
    NEXT i

n$ = "slotcalc.csv"
d1b = 1
dmp = 0
if COMMAND$ = "" THEN
	print "No input file name specified"
	stop
	end if
n$ = COMMAND$
k=instr(n$,",")
if k>=0 then
	nsize=val(left$(n$,k-1))
	n$=mid$(n$,k+1)
	end if
if left$(n$,1)="!" then
	dmp = 1
	n$=mid$(n$,2)
	end if
if left$(n$,1)="+" then
	n$=mid$(n$,2)
	d1b = 2
	end if

OPEN "i", 1, n$
l1: LINE INPUT #1, d$
    IF d$ <> "" THEN
        m$ = LEFT$(d$, 2)
        IF RIGHT$(m$, 1) = "/" THEN 
		m$ = "0" + LEFT$(m$, 1)
		d$ = "0" + d$
		end if
	if mid$(d$,5,1)="/" then
		d$=left$(d$,3)+"0"+mid$(d$,4)
		end if 
        y$ = RIGHT$(d$, 4)
        IF MID$(y$, 2, 1) = "/" THEN y$ = "20" + RIGHT$(y$, 2)
        dx$ = y$ + m$
        if mid$(d$,4,2)<="15" then d1 = 1 else d1 = d1b
        FOR i = 1 TO nslot
            IF dx$ = slot$(i) THEN
                slot2(d1,i) = slot2(d1,i) + 1
                GOTO s1
                END IF
            NEXT i
        PRINT "Ignoring: ";d$
        END IF
s1: IF NOT EOF(1) GOTO l1
CLOSE #1

if dmp>0 then
	open "o",1,"slotcalc.slt"
	for i=1 to nslot
		print #1,slot$(i),slot2(1,i);slot2(2,i)
		next i
	close #1
	end if

st$ = slot$(1)
if len(st$)<8 then st$=st$+" "
en$ = slot$(1)
n1 = 0
t1$ = CHR$(9)
t2$ = CHR$(9) + CHR$(9)
t3$ = t1$ + t2$

ofn$ = LEFT$(n$, LEN(n$) - 3) + "txt"
OPEN "o", 1, ofn$
PRINT #1, "Start"; t3$; "End"; t3$; "Total"; t1$; "Next"; t1$; "Need"
PRINT #1,
fx2$ = LEFT$(n$, LEN(n$) - 4) + ".dat"
fx3$ = LEFT$(n$, LEN(n$) - 4) + "1.dat"
OPEN "i", 2, fx2$
open "o", 3, fx3$
flag = 0
kslot = 0
FOR i = 1 TO nslot
    IF (n1 + slot2(1,i)) > nsize THEN
        kslot = kslot + 1
	if kslot>20 then gosub xkslot
        r1$(kslot) = LEFT$(st$, 4) + "-" + MID$(st$, 5)
        r2$(kslot) = LEFT$(en$, 4) + "-" + RIGHT$(en$, 2) + " "
        INPUT #2, x1$, x2$
        IF x1$="" then
            x1$=r1$(kslot)
            x2$=r2$(kslot)
            flag = 2
            endif
	if len(x1$)<8 then x1$=left$(x1$+"         ",8)
	if len(x2$)<8 then x2$=left$(x2$+"         ",8)
        PRINT #3, x1$;",";x2$
        s1$ = t2$
        s2$ = t2$
        IF x1$ <> r1$(kslot) THEN s1$ = " ** ("+x1$+")"+t1$
        IF x2$ <> r2$(kslot) THEN s2$ = " ** ("+x2$+")"+t1$
        IF len(s1$ + s2$) > 6 THEN flag = 1
        PRINT #1, r1$(kslot); s1$; r2$(kslot); s2$; n1; t1$; slot2(1,i); t1$; slot2(1,i) - nsize + n1
        n1 = 0
        st$ = slot$(i)+" "
        END IF
    n1 = n1 + slot2(1,i)
    IF (n1 + slot2(2,i)) > nsize THEN
        kslot = kslot + 1
	if kslot>20 then gosub xkslot
	en$ = slot$(i)
        r1$(kslot) = LEFT$(st$, 4) + "-" + MID$(st$, 5)
        r2$(kslot) = LEFT$(en$, 4) + "-" + RIGHT$(en$, 2) + "+"
        INPUT #2, x1$, x2$
        IF x1$="" then
            x1$=r1$(kslot)
            x2$=r2$(kslot)
            flag = 2
            endif
	if len(x1$)<8 then x1$=left$(x1$+"         ",8)
	if len(x2$)<8 then x2$=left$(x2$+"         ",8)
        PRINT #3, x1$;",";x2$
        s1$ = t2$
        s2$ = t2$
        IF x1$ <> r1$(kslot) THEN s1$ = " ** ("+x1$+")"+t1$
        IF x2$ <> r2$(kslot) THEN s2$ = " ** ("+x2$+")"+t1$
        IF len(s1$ + s2$) > 6 THEN flag = 1
        PRINT #1, r1$(kslot); s1$; r2$(kslot); s2$; n1; t1$; slot2(2,i); t1$; slot2(2,i) - nsize + n1
        n1 = 0
        st$ = slot$(i)+"+"
        END IF
    n1 = n1 + slot2(2,i)
    en$ = slot$(i)
    NEXT i
kslot = kslot + 1
if kslot>20 then gosub xkslot
r1$(kslot) = LEFT$(st$, 4) + "-" + MID$(st$, 5)
r2$(kslot) = LEFT$(en$, 4) + "-" + RIGHT$(en$, 2) + " "
INPUT #2, x1$, x2$
IF x1$="" then
    x1$=r1$(kslot)
    x2$=r2$(kslot)
    endif
if len(x1$)<8 then x1$=left$(x1$+"         ",8)
if len(x2$)<8 then x2$=left$(x2$+"         ",8)
PRINT #3, x1$;",";x2$
s1$ = t2$
s2$ = t2$
IF x1$ <> r1$(kslot) THEN s1$ = " ** ("+x1$+")"+t1$
IF x2$ <> r2$(kslot) THEN s2$ = " ** ("+x2$+")"+t1$
IF len(s1$ + s2$) > 6 THEN flag = 1
PRINT #1, r1$(kslot); s1$; r2$(kslot); s2$; n1

IF flag > 0 THEN
    PRINT #1,
    if flag=1 then
	PRINT #1, "**";t1$;"This slot has changed since last run"
	PRINT #1, t1$;"Last run data in parenthesis"
	end if
    if flag=2 then PRINT #1, "** New slot data file created"
    CLOSE #2
    fx0$ = LEFT$(n$, LEN(n$) - 4) + ".new"
    OPEN "o", 2, fx0$
    FOR i = 1 TO kslot
        PRINT #2, r1$(i); ","; r2$(i)
        NEXT i
    END IF

print #1,
print #1,
if d1b=1 then
	print #1,"Start";t1$ + "is the beginning of the month."
	print #1,"End";t1$;"is the last day of the month. "
	end if
if d1b=2 then
	print #1,"Start";t1$;"is the first of the month unless there is a '+' suffix which means the 16th."
	print #1,"End";t1$;"is the last day of the month unless there is a '+' suffix which means the 15th."
	end if
print #1,"Total";t1$;"is the total caches in the range."
print #1,"Next";t1$;"is the count for the next month that wouldn't fit."
print #1,"Need";t1$;"is how many more needed before change."

CLOSE #1, #2, #3

END

xkslot:
print "The slot size and input data results in more than 20 slots."
input x$
stop
return

